import 'package:flutter/material.dart';
import 'package:provider/provider.dart';

import '../../dotup_flutter_simulator.dart';
import 'android_navigation_bar.dart';
import 'display_content.dart';
import 'display_content_descriptor.dart';
import 'display_frame.dart';
import 'status_bar.dart';

class DisplayContainer extends StatelessWidget {
  const DisplayContainer(
      {Key? key,
      // required this.device,
      required this.screenSize,
      required this.child,
      required this.backgroundColor,
      required this.navigationBarBackgroundColor,
      required this.showBatterieStatusPercentage})
      : super(key: key);

  // final DeviceDescriptor device;
  final Size screenSize;
  final WidgetBuilder child;
  final Color backgroundColor;
  final Color navigationBarBackgroundColor;
  final bool showBatterieStatusPercentage;

  // TODO: get device
  @override
  Widget build(BuildContext context) {
    final content = DisplayContent(
      statusBar: DisplayContentDescriptor(
        height: 24,
        widget: Material(
          child: StatusBar(
            key: GlobalKey(),
            height: 24,
            backgroundColor: Colors.black45,
            text: 'dotup.de',
            showBatterieStatusPercentage: showBatterieStatusPercentage,
          ),
        ),
      ), // StatusBar(),
      body: child(context),
      menuBar: DisplayContentDescriptor(
        height: 48,
        widget: IconTheme(
          key: GlobalKey(),
          data: IconThemeData(color: Colors.red),
          child: AndroidNavigationBar(
            height: 48,
            width: screenSize.width,
            color: navigationBarBackgroundColor,
            iconColor: Colors.white38,
          ),
        ),
      ),
    );

    return Material(
      child: InkWell(
        onLongPress: () => Provider.of<SimulatorController>(context, listen: false).toggleMenu(),
        onDoubleTap: () => Provider.of<SimulatorController>(context, listen: false).toggleMenu(),
        child: Container(
          color: backgroundColor,
          child: Center(
            child: DisplayFrame(
              child: content,
              screenSize: screenSize,
            ),
          ),
        ),
      ),
    );
  }
}
